﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using MikuMikuDance.XNA.Motion;
using Microsoft.Xna.Framework.Content;

namespace MikuMikuDance.XNA.Model
{
    /// <summary>
    /// MMDモデルクラス
    /// </summary>
    public class MMDModelContent
    {
        /// <summary>
        /// このモデルのメッシュパーツ
        /// </summary>
        public List<MMDModelPartContent> ModelParts = new List<MMDModelPartContent>();
        /// <summary>
        /// ボーンマネージャ
        /// </summary>
        public MMDBoneManagerContent BoneManager;
        /// <summary>
        /// 付随モーション
        /// </summary>
        public Dictionary<string, MMDMotionDataContent> AttachedMotionData;

        /// <summary>
        /// モデルパーツ追加
        /// </summary>
        /// <param name="triangleCount">三角形の追加</param>
        /// <param name="indexCollection">インデックスコレクション</param>
        /// <param name="vertices">頂点データ</param>
        /// <param name="material">マテリアルデータ</param>
        public void AddModelPart(int triangleCount, IndexCollection indexCollection, MMDVertexContent[] vertices, BasicMaterialContent material)
        {
            if (material == null)
                throw new ArgumentNullException("material");

            ModelParts.Add(new MMDModelPartContent
            {
                TriangleCount = triangleCount,
                IndexCollection = indexCollection,
                Vertices = vertices,
                Material = material,
            });
        }
    }
    
}
