﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MikuMikuDance.XNA.Model;
using Microsoft.Xna.Framework.Content;
using MikuMikuDance.XNA.Motion;
using MikuMikuDance.XNA.Misc;

namespace MikuMikuDance.XNA
{
    public class MikuMikuDanceXNA
    {
        public static MikuMikuDanceXNA m_inst;
        public static MikuMikuDanceXNA Instance
        {
            get
            {
                if (m_inst == null)
                    m_inst = new MikuMikuDanceXNA();
                return m_inst;
            }
        }

        public IIKSolver IKSolver { get; set; }
        public IIKLimitter IKLimitter { get; set; }
        protected MikuMikuDanceXNA()
        {
            //外部からつくらせない
            //IKソルバとリミッター
            IKSolver = new CCDSolver();
            IKLimitter = new DefaltIKLimitter();
        }
        

        public MMDModel LoadModel(string assetName, ContentManager content)
        {
            return content.Load<MMDModel>(assetName);
        }
        public MMDMotionData LoadMotion(string assetName, ContentManager content)
        {
            return content.Load<MMDMotionData>(assetName);
        }
    }
}
