﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using MikuMikuDance.XNA.Threads;

namespace MikuMikuDance.XNA.Misc
{
    public delegate void BeginMarkDelegate(int mmdxThreadIndex, string key, Color color);
    public delegate void EndMarkDelegate(int mmdxThreadIndex, string key);

    public static class MMDProfiler
    {
        public static event BeginMarkDelegate MMDBeginMark;
        public static event EndMarkDelegate MMDEndMark;
        internal static void BeginMark(string key, Color color)
        {
            if (MMDBeginMark != null)
            {
                int threadIndex = MMDThreadManager.ThreadID;//ThreadID取得
                MMDBeginMark(threadIndex, key, color);
            }
        }
        internal static void EndMark(string key)
        {
            if (MMDEndMark != null)
            {
                int threadIndex = MMDThreadManager.ThreadID;//ThreadID取得
                MMDEndMark(threadIndex, key);
            }
        }
    }
}
