using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using MikuMikuDance.XNA.Misc;

namespace MikuMikuDance.XNA.Model
{
    /// <summary>
    /// MMDBoneのコンテンツリーダー
    /// </summary>
    public class MMDBoneReader : ContentTypeReader<MMDBone>
    {
        /// <summary>
        /// モデルボーンの読み込み
        /// </summary>
        protected override MMDBone Read(ContentReader input, MMDBone existingInstance)
        {
            SQTTransform bindPose = input.ReadObject<SQTTransform>();
            Matrix invPose = input.ReadObject<Matrix>();
            //ushort ikp = input.ReadUInt16();
            string name = input.ReadString();
            int sh = input.ReadInt32();
            List<int> iks = input.ReadObject<List<int>>();
            return new MMDBone(name, bindPose, invPose, sh, iks);
        }
    }
}
