using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace MikuMikuDance.XNA.Model
{
    /// <summary>
    /// ModelPart̓ǂݍݗp^Cv[_
    /// </summary>
    public class MMDModelPartReader : ContentTypeReader<MMDModelPart>
    {
        /// <summary>
        /// fp[c̓ǂݍ
        /// </summary>
        protected override MMDModelPart Read(ContentReader input, MMDModelPart existingInstance)
        {
            //fp[c̓ǂݍ
            int triangleCount = input.ReadInt32();
            MMDVertex[] Vertices = input.ReadObject<MMDVertex[]>();
            IndexBuffer indexBuffer = input.ReadObject<IndexBuffer>();

            // create the model part from this data
            MMDModelPart modelPart = MMDModelPart.Create(triangleCount, Vertices, indexBuffer);

            // read in the BasicEffect as a shared resource
            input.ReadSharedResource<BasicEffect>(fx => modelPart.Effect = fx);

            return modelPart;
        }
    }
}
