﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MikuMikuDance.XNA.Misc;
using Microsoft.Xna.Framework;

namespace MikuMikuDance.XNA.Model
{
    static class SkinningHelpers
    {
        public static void SkinVertex(Matrix[] bones, MMDVertex vertin, out Vector3 outPosition)
        {
            //影響ボーン取得
            int b0 = vertin.BlendIndexX;
            int b1 = vertin.BlendIndexY;
            //ボーンマトリックスをブレンド
            Matrix skinnedTransformSum;
            Blend4x3Matrix(ref bones[b0], ref bones[b1], ref vertin.BlendWeights, out skinnedTransformSum);

            //ブレンドしたボーンによる変換を頂点に適応
            Vector3.Transform(ref vertin.Position, ref skinnedTransformSum, out outPosition);
        }
        public static void SkinVertex(Matrix[] bones, MMDVertexNm vertin, out Vector3 outPosition, out Vector3 outNormal)
        {
            //影響ボーン取得
            int b0 = vertin.BlendIndexX;
            int b1 = vertin.BlendIndexY;
            
            //ボーンマトリックスをブレンド
            Matrix skinnedTransformSum;
            Blend4x3Matrix(ref bones[b0], ref bones[b1], ref vertin.BlendWeights, out skinnedTransformSum);
            //ブレンドしたボーンによる変換を頂点に適応
            Vector3.Transform(ref vertin.Position, ref skinnedTransformSum, out outPosition);
            Vector3.TransformNormal(ref vertin.Normal, ref skinnedTransformSum, out outNormal);
        }

        static void Blend4x3Matrix(ref Matrix m1, ref Matrix m2, ref Vector2 weights, out Matrix blended)
        {
            float w1 = weights.X;
            float w2 = weights.Y;

            blended.M11 = (m1.M11 * w1) + (m2.M11 * w2);
            blended.M12 = (m1.M12 * w1) + (m2.M12 * w2);
            blended.M13 = (m1.M13 * w1) + (m2.M13 * w2);
            blended.M21 = (m1.M21 * w1) + (m2.M21 * w2);
            blended.M22 = (m1.M22 * w1) + (m2.M22 * w2);
            blended.M23 = (m1.M23 * w1) + (m2.M23 * w2);
            blended.M31 = (m1.M31 * w1) + (m2.M31 * w2);
            blended.M32 = (m1.M32 * w1) + (m2.M32 * w2);
            blended.M33 = (m1.M33 * w1) + (m2.M33 * w2);
            blended.M41 = (m1.M41 * w1) + (m2.M41 * w2);
            blended.M42 = (m1.M42 * w1) + (m2.M42 * w2);
            blended.M43 = (m1.M43 * w1) + (m2.M43 * w2);

            blended.M14 = 0.0f;
            blended.M24 = 0.0f;
            blended.M34 = 0.0f;
            blended.M44 = 1.0f;
            /*float num11 = (m1.M11 * w1) + (m2.M11 * w2);
            float num12 = (m1.M12 * w1) + (m2.M12 * w2);
            float num13 = (m1.M13 * w1) + (m2.M13 * w2);
            float num21 = (m1.M21 * w1) + (m2.M21 * w2);
            float num22 = (m1.M22 * w1) + (m2.M22 * w2);
            float num23 = (m1.M23 * w1) + (m2.M23 * w2);
            float num31 = (m1.M31 * w1) + (m2.M31 * w2);
            float num32 = (m1.M32 * w1) + (m2.M32 * w2);
            float num33 = (m1.M33 * w1) + (m2.M33 * w2);
            float num41 = (m1.M41 * w1) + (m2.M41 * w2);
            float num42 = (m1.M42 * w1) + (m2.M42 * w2);
            float num43 = (m1.M43 * w1) + (m2.M43 * w2);
            
            blended.M11 = num11;
            blended.M12 = num12;
            blended.M13 = num13;
            blended.M14 = 0.0f;
            blended.M21 = num21;
            blended.M22 = num22;
            blended.M23 = num23;
            blended.M24 = 0.0f;
            blended.M31 = num31;
            blended.M32 = num32;
            blended.M33 = num33;
            blended.M34 = 0.0f;
            blended.M41 = num41;
            blended.M42 = num42;
            blended.M43 = num43;
            blended.M44 = 1.0f;*/
        }

    }
}
